//DatumPoint version 0.1a
//Written by Terrey West (Ter13)
//(c) 9/15/2013
//This work is provided as-is. Distribution of contents of the contained files
//should retain credit to the original author.
//Use of this product for commercial purposes is allowed permitted, so long as
//significant modifications to this file have been documented.
//Outright sale of this library is not permitted. Sale of derivative works, however,
//is permitted, so long as a link to the original is maintained readily visible.

atom/movable
	var
		remainder_x = 0
		remainder_y = 0

point
	var
		x = 1
		y = 1
		z = 1
	proc
		getTileX()
			return round(x/TILE_WIDTH)

		getTileY()
			return round(y/TILE_HEIGHT)

		getPixelX()
			return (x%TILE_WIDTH)

		getPixelY()
			return (y%TILE_HEIGHT)

		getRemainderX()
			return decimal(x)

		getRemainderY()
			return decimal(y)

		getLoc()
			return locate(round(x/TILE_WIDTH)+1,round(y/TILE_HEIGHT)+1,z)

		//Add(point)
		//Add(atom)
		//Add(x,y,z)
		//Add(xtiles,ytiles,xstep,ystep,z)
		//Add(xtiles,ytiles,xstep,ystep,xremainder,yremainder,z)
		Add()
			if(istype(args[1],/point))
				var/point/p = args[1]
				x += p.x
				y += p.y
				z += p.z
			else if(istype(args[1],/atom/movable))
				var/atom/movable/o = args[1]
				x += o.x*TILE_WIDTH + o.step_x + o.remainder_x + o.bound_x
				y += o.y*TILE_HEIGHT + o.step_y + o.remainder_y + o.bound_y
				z += o.z
			else if(istype(args[1],/atom))
				var/atom/a = args[1]
				x += a.x*TILE_WIDTH
				y += a.y*TILE_HEIGHT
				z += a.z
			else
				if(args.len>5)
					x += args[1]*TILE_WIDTH + args[3] + args[5]
					y += args[2]*TILE_HEIGHT + args[4] + args[6]
					if(args.len==7)
						z += args[7]
				else if(args.len>3)
					x += args[1]*TILE_WIDTH + args[3]
					y += args[2]*TILE_HEIGHT + args[4]
					if(args.len==5)
						z += args[5]
				else if(args.len>1)
					x += args[1]
					y += args[2]
					if(args.len==3)
						z += args[3]
		Sub()
			if(istype(args[1],/point))
				var/point/p = args[1]
				x -= p.x
				y -= p.y
				z -= p.z
			else if(istype(args[1],/atom/movable))
				var/atom/movable/o = args[1]
				x -= o.x*TILE_WIDTH + o.step_x + o.remainder_x + o.bound_x
				y -= o.y*TILE_HEIGHT + o.step_y + o.remainder_y + o.bound_y
				z -= o.z
			else if(istype(args[1],/atom))
				var/atom/a = args[1]
				x -= a.x*TILE_WIDTH
				y -= a.y*TILE_HEIGHT
				z -= a.z
			else
				if(args.len>5)
					x -= args[1]*TILE_WIDTH + args[3] + args[5]
					y -= args[2]*TILE_HEIGHT + args[4] + args[6]
					if(args.len==7)
						z += args[7]
				else if(args.len>3)
					x -= args[1]*TILE_WIDTH + args[3]
					y -= args[2]*TILE_HEIGHT + args[4]
					if(args.len==5)
						z -= args[5]
				else if(args.len>1)
					x -= args[1]
					y -= args[2]
					if(args.len==3)
						z -= args[3]
		//mul(matrix)
		Mul()
			if(istype(args[1],/point))
				var/point/p = args[1]
				x *= p.x
				y *= p.y
				z *= p.z
			else if(istype(args[1],/atom/movable))
				var/atom/movable/o = args[1]
				x *= o.x*TILE_WIDTH + o.step_x + o.remainder_x + o.bound_x
				y *= o.y*TILE_HEIGHT + o.step_y + o.remainder_y + o.bound_y
				z *= o.z
			else if(istype(args[1],/atom))
				var/atom/a = args[1]
				x *= a.x*TILE_WIDTH
				y *= a.y*TILE_HEIGHT
				z *= a.z
			else if(istype(args[1],/matrix))
				var/matrix/m = matrix(1,0,x,0,1,y)
				m = m*args[1]
				x = m.c
				y = m.f
			else
				if(args.len>5)
					x *= args[1]*TILE_WIDTH + args[3] + args[5]
					y *= args[2]*TILE_HEIGHT + args[4] + args[6]
					if(args.len==7)
						z *= args[7]
				else if(args.len>3)
					x *= args[1]*TILE_WIDTH + args[3]
					y *= args[2]*TILE_HEIGHT + args[4]
					if(args.len==5)
						z *= args[5]
				else if(args.len>1)
					x *= args[1]
					y *= args[2]
					if(args.len==3)
						z += args[3]
		Div()
			if(istype(args[1],/point))
				var/point/p = args[1]
				x /= p.x
				y /= p.y
				z /= p.z
			else if(istype(args[1],/atom/movable))
				var/atom/movable/o = args[1]
				x /= o.x*TILE_WIDTH + o.step_x + o.remainder_x + o.bound_x
				y /= o.y*TILE_HEIGHT + o.step_y + o.remainder_y + o.bound_y
				z /= o.z
			else if(istype(args[1],/atom))
				var/atom/a = args[1]
				x /= a.x*TILE_WIDTH
				y /= a.y*TILE_HEIGHT
				z /= a.z
			else
				if(args.len>5)
					x /= args[1]*TILE_WIDTH + args[3] + args[5]
					y /= args[2]*TILE_HEIGHT + args[4] + args[6]
					if(args.len==7)
						z /= args[7]
				else if(args.len>3)
					x /= args[1]*TILE_WIDTH + args[3]
					y /= args[2]*TILE_HEIGHT + args[4]
					if(args.len==5)
						z /= args[5]
				else if(args.len>1)
					x /= args[1]
					y /= args[2]
					if(args.len==3)
						z /= args[3]

		//clamp(minx,miny,minz,maxx,maxy,maxz)
		//clamp(point,point)
		//clamp(minx,miny,maxx,maxy)
		Clamp()
			if(args.len==2)
				var/point/lp = args[1]
				var/point/hp = args[2]
				x = min(hp.x,max(lp.x,x))
				y = min(hp.y,max(lp.y,y))
			else if(args.len==4)
				x = min(args[3],max(args[1],x))
				y = min(args[4],max(args[2],y))
			else if(args.len==6)
				x = min(args[4],max(args[1],x))
				y = min(args[5],max(args[2],y))
				z = min(args[6],max(args[3],z))

		//RotateAround(point,matrix)
		//RotateAround(point,angle)

		//RotateAround(x,y,matrix)
		//RotateAround(x,y,angle)

		//RotateAround(atom,matrix)
		//RotateAround(atom,angle)
		//RotateAround(atom,xoffset,yoffset,matrix)
		//RotateAround(atom,xoffset,yoffset,angle)

		//RotateAround(movable,matrix)
		//RotateAround(movable,angle)
		//RotateAround(movable,xoffset,yoffset,matrix)
		//RotateAround(movable,xoffset,yoffset,angle)
		RotateAround()
			var/matrix/m
			var/nx = 0
			var/ny = 0
			if(istype(args[1],/point))
				var/point/p = args[1]
				nx = p.x
				ny = p.y
			else if(istype(args[1],/atom/movable))
				var/atom/movable/o = args[1]
				nx = o.x*TILE_WIDTH+o.step_x+o.remainder_x+o.bound_x
				ny = o.y*TILE_HEIGHT+o.step_y+o.remainder_y+o.bound_y
			else if(istype(args[1],/atom))
				var/atom/o = args[1]
				nx = o.x*TILE_WIDTH
				ny = o.y*TILE_HEIGHT
			else
				nx = args[1]
				ny = args[2]
			if(istype(args[args.len],/matrix))
				m = args[args.len]
				var/ox = x-nx
				var/oy = y-ny
				src.x = ox*m.a + oy*m.b + m.c + nx
				src.y = ox*m.d + oy*m.e + m.f + ny
			else
				m = matrix(1,0,x-nx,0,1,y-ny)
				m.Turn(args[args.len])
				x = m.c+nx
				y = m.f+ny

		Move(var/atom/movable/o)
			o.x = round(x/TILE_WIDTH)
			o.y = round(y/TILE_HEIGHT)
			o.z = z
			o.step_x = x%TILE_WIDTH
			o.step_y = y%TILE_HEIGHT
			o.remainder_x = decimal(x)
			o.remainder_y = decimal(y)

		//Set(point)
		//Set(atom)
		//Set(movable)
		//Set(x,y)
		//Set(x,y,z)
		//Set(tilex,tiley,stepx,stepy)
		//Set(tilex,tiley,tilez,stepx,stepy)
		//Set(tilex,tiley,stepx,stepy,remainderx,remaindery)
		//Set(tilex,tiley,tilez,stepx,stepy,remainderx,remaindery)
		Set()
			if(args.len==1)
				if(istype(args[1],/point))
					var/point/p = args[1]
					x = p.x
					y = p.y
					z = p.z
				else if(istype(args[1],/atom/movable))
					var/atom/movable/o = args[1]
					x = (o.x-1)*TILE_WIDTH+o.step_x+o.remainder_x+o.bound_x
					y = (o.y-1)*TILE_HEIGHT+o.step_y+o.remainder_y+o.bound_y
					z = o.z
				else if(istype(args[1],/atom))
					var/atom/a = args[1]
					x = (a.x-1)*TILE_WIDTH
					y = (a.y-1)*TILE_HEIGHT
					z = a.z
			else if(args.len==2)
				x = args[1]
				y = args[2]
			else if(args.len==3)
				x = args[1]
				y = args[2]
				z = args[3]
			else if(args.len==4)
				x = args[1]*TILE_WIDTH + args[3]
				y = args[2]*TILE_HEIGHT + args[4]
			else if(args.len==5)
				x = args[1]*TILE_WIDTH + args[4]
				y = args[2]*TILE_HEIGHT + args[5]
				z = args[3]
			else if(args.len==6)
				x = args[1]*TILE_WIDTH + args[3] + args[5]
				y = args[2]*TILE_HEIGHT + args[4] + args[6]
			else if(args.len==7)
				x = args[1]*TILE_WIDTH + args[4] + args[6]
				y = args[2]*TILE_HEIGHT + args[5] + args[7]
				z = args[3]

		//isInside(point,point)
		//isInside(x,y,z,x,y,z)
		//isInside(atom)
		//isInside(movable)
		isInside()
			var/x1 = 0
			var/x2 = 0
			var/y1 = 0
			var/y2 = 0
			var/z1 = 0
			var/z2 = 0
			if(istype(args[1],/point))
				var/point/p1 = args[1]
				var/point/p2 = args[2]
				x1 = p1.x
				y1 = p1.y
				z1 = p1.z
				x2 = p2.x
				y2 = p2.y
				z2 = p2.z
			else if(istype(args[1],/atom/movable))
				var/atom/movable/o = args[1]
				x1 = o.x*TILE_WIDTH + o.step_x + o.bound_x
				y1 = o.y*TILE_HEIGHT + o.step_y + o.bound_y
				z1 = o.z
				x2 = x1+o.bound_width - 1
				y2 = y1+o.bound_height - 1
				z2 = z1
			else if(istype(args[1],/area))
				var/turf/t = locate(round(x/TILE_WIDTH),round(y/TILE_HEIGHT),z)
				if(t&&t.loc==args[1])
					return 1
				else
					return 0
			else if(istype(args[1],/atom))
				var/atom/o = args[1]
				x1 = o.x*TILE_WIDTH
				y1 = o.y*TILE_HEIGHT
				z1 = o.z
				x2 = x1+TILE_WIDTH-1
				y2 = y1+TILE_HEIGHT-1
				z2 = z1
			else
				x1 = args[1]
				y1 = args[2]
				z1 = args[3]
				x2 = args[4]
				y2 = args[5]
				z2 = args[6]
			if(x>=x1&&x<=x2&&y>=y1&&x<=y2&&z>=z1&&z<=z2)
				return 1
			return 0

	New()
		src.Set(arglist(args))